﻿namespace CSharpConsole
{
    using System;
    using IronRuby;
    using IronRuby.Builtins;

    public class Program
    {
        public static void Main(string[] args)
        {
            var ruby = Ruby.GetEngine(Ruby.CreateRuntime());
            ruby.Execute(@"
                $m = lambda {
                        a = Array.new
                        a.push(2, 3)
                        (4..50).each do
                           |i|
                           (2..(Math.sqrt(i).ceil)).each do
                              |thing|
                              if (i.divmod(thing)[1] == 0)
                                 a.push i
                                 break
                              end
                           end
                        end
                        return a
                     }
            ");
            var rubyContext = Ruby.GetExecutionContext(ruby);
            var m = (Proc)rubyContext.GetGlobalVariable("m");
            var rubyArray = (RubyArray) m.Call();

            Console.WriteLine("Return values from function:");
            
            foreach (var o in rubyArray)
            {
                Console.Write(string.Format("{0},", o));
            }

            Console.ReadLine();
        }
    }
}
